/*
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "gridftp_namespace.h"
#include <exceptions/cpp_to_gerror.hpp>


bool GridftpModule::exists(const char* path)
{
    try {
        gfal_globus_stat_t gl_stat;
        memset(&gl_stat,0, sizeof(gfal_globus_stat_t));
        internal_globus_gass_stat(path, &gl_stat);
    }
    catch (Gfal::CoreException& e) {
        if (e.code() != ENOENT)
            throw;
        return false;
    }
    return true;
}
